import * as rules from "./rules";
declare let Rules: {
    in: typeof rules.in;
    notIn: typeof rules.notIn;
    accepted(args?: string[]): import("..").ValidationRuleContract;
    acceptedIf(args: string[], acceptedValues?: string[]): import("..").ValidationRuleContract;
    acceptedNotIf(args: string[], acceptedValues?: string[]): import("..").ValidationRuleContract;
    alpha(): import("..").ValidationRuleContract;
    alphaDash(): import("..").ValidationRuleContract;
    alphaHyphen(): import("..").ValidationRuleContract;
    alphaNumeric(): import("..").ValidationRuleContract;
    alphaNumericDash(): import("..").ValidationRuleContract;
    array(): import("..").ValidationRuleContract;
    arrayUnique(): import("..").ValidationRuleContract;
    arrayUniqueObjects(args: string[]): import("..").ValidationRuleContract;
    arrayLen(args: string[]): import("..").ValidationRuleContract;
    arrayLenRange(args: string[]): import("..").ValidationRuleContract;
    arrayLenMin(args: string[]): import("..").ValidationRuleContract;
    arrayLenMax(args: string[]): import("..").ValidationRuleContract;
    between(args: string[]): import("..").ValidationRuleContract;
    booleanStr(): import("..").ValidationRuleContract;
    booleanInt(): import("..").ValidationRuleContract;
    booleanStrict(): import("..").ValidationRuleContract;
    boolean(args?: any[]): import("..").ValidationRuleContract;
    confirmed(args?: string[]): import("..").ValidationRuleContract;
    contains(args: string[]): import("..").ValidationRuleContract;
    notContains(args: any[]): import("..").ValidationRuleContract;
    creditCard(): import("..").ValidationRuleContract;
    dateAfter(args: (string | number | Date)[]): import("..").ValidationRuleContract;
    after(args: (string | number | Date)[]): import("..").ValidationRuleContract;
    dateAfterToday(args: string[]): import("..").ValidationRuleContract;
    dateBefore(args: any[]): import("..").ValidationRuleContract;
    before(args: (string | number | Date)[]): import("..").ValidationRuleContract;
    dateBeforeToday(args: string[]): import("..").ValidationRuleContract;
    dateFormat(args: string[]): import("..").ValidationRuleContract;
    dateISO(): import("..").ValidationRuleContract;
    datetime(): import("..").ValidationRuleContract;
    date(args?: string[]): import("..").ValidationRuleContract;
    dateiso(): import("..").ValidationRuleContract;
    iso8601(): import("..").ValidationRuleContract;
    different(args: any[]): import("..").ValidationRuleContract;
    digits(args?: string[]): import("..").ValidationRuleContract;
    digitsBetween(args?: string[]): import("..").ValidationRuleContract;
    domain(): import("..").ValidationRuleContract;
    email(): import("..").ValidationRuleContract;
    ascii(): import("..").ValidationRuleContract;
    json(): import("..").ValidationRuleContract;
    base64(args?: "urlsafe"[]): import("..").ValidationRuleContract;
    equals(args: string[]): import("..").ValidationRuleContract;
    gt(args: string[]): import("..").ValidationRuleContract;
    gte(args: any[]): import("..").ValidationRuleContract;
    hash(args: any[]): import("..").ValidationRuleContract;
    hex(): import("..").ValidationRuleContract;
    hexColor(): import("..").ValidationRuleContract;
    ip(args?: ("4" | "6")[]): import("..").ValidationRuleContract;
    latLong(args?: "dms"[]): import("..").ValidationRuleContract;
    maxLength(args: string[]): import("..").ValidationRuleContract;
    minLength(args: string[]): import("..").ValidationRuleContract;
    length(args: string[]): import("..").ValidationRuleContract;
    lengthBetween(args: string[]): import("..").ValidationRuleContract;
    lt(args: string[]): import("..").ValidationRuleContract;
    lte(args: any[]): import("..").ValidationRuleContract;
    macAddress(): import("..").ValidationRuleContract;
    mime(args: string[], trust?: boolean): import("..").ValidationRuleContract;
    mongoId(): import("..").ValidationRuleContract;
    integer(args?: "0"[]): import("..").ValidationRuleContract;
    min(args: string[]): import("..").ValidationRuleContract;
    max(args: string[]): import("..").ValidationRuleContract;
    decimal(): import("..").ValidationRuleContract;
    numeric(): import("..").ValidationRuleContract;
    object(): import("..").ValidationRuleContract;
    phoneNumber(args?: string[]): import("..").ValidationRuleContract;
    regex(args: any[]): import("..").ValidationRuleContract;
    required(): import("..").ValidationRuleContract;
    requiredIf(args: string[]): import("..").ValidationRuleContract;
    requiredWithout(args: string[]): import("..").ValidationRuleContract;
    requiredWithoutAll(args: string[]): import("..").ValidationRuleContract;
    requiredWith(args: string[]): import("..").ValidationRuleContract;
    requiredWithAll(args: string[]): import("..").ValidationRuleContract;
    same(args: string[]): import("..").ValidationRuleContract;
    size(args: string[], trust?: boolean): import("..").ValidationRuleContract;
    nullable(): import("..").ValidationRuleContract;
    sometimes(): import("..").ValidationRuleContract;
    string(): import("..").ValidationRuleContract;
    url(args?: string[]): import("..").ValidationRuleContract;
    validator(name: string, args?: any[]): import("..").ValidationRuleContract;
};
export default Rules;
